﻿program LunchOrdering_ImportMenus;
info
  Title = 'Import menu';               // Script Title
  Keywords = '';            // Script Keywords
  Author = 'Ladislav Šnajdr';            // Script Author
  AS3Compatible = False;      // Script is runable under AS
  DefaultDM = '';           // Default data module, used in AS
end;

Modules
  TSpecialLunchMenu,
  TSpecialLunchMeal,
  TSpecialLunchAlergens;

Const
//// Menu rows: ////
//Soups
Soup_1 = 6;
Soup_2 = 10;

//Main courses
Main_1 = 14;
Main_2 = 19;
Main_3 = 24;
Main_4 = 29;
Main_5 = 34;

//// Menu cols: ////
Menu_mon = 3;
Menu_tue = 5;
Menu_wed = 7;
Menu_thu = 9;
Menu_fri = 11;

//// Special ////
date_row = 4; // Date je menu day - 1

//Weeklong main course
Spec_Col = 9;
Spec_Row = 43;

//Status je hardcoded
activeStatusID = 5028;

type
  TMealType = (
    tpSoup,
    tpMainCourse,
    tpWeeklyCourse
  );

  TMealItem = record
    MenuID : Integer;
    Name : String;
    Alergens : String;
  end;

  TDayMenu = record
    Holiday      : boolean;
    MenuDate     : TDateTime;
    Soups        : Array [1..2] of TMealItem;
    MainCourses  : Array [1..5] of TMealItem;
    WeeklyCourse : TMealItem;
  end;

var
  OpenDialog : TOpenDialog;
  XlsMenuPath : string;
  MenuBatch : Array [1..5] of TDayMenu;
  i, j : integer;
  e : TCellData;

  TMenu : TSpecialLunchMenu;
  TMenuMeal : TSpecialLunchMenuMealChild;
  TMeal : TSpecialLunchMeal;
  TMealAlergen : TSpecialLunchMealAlergenChild;
  TAlergen : TSpecialLunchAlergens;

procedure OpenMenuFile;
begin
  OpenDialog := TOpenDialog.Create(0);
  OpenDialog.Title := 'Vyberte excel s menu';
  OpenDialog.InitialDir := 'c:\VzorMenu\';
  OpenDialog.Filter := 'Soubor *.xls|*.xls';
  if OpenDialog.Execute then
    XlsMenuPath := OpenDialog.FileName;
  OpenDialog.Free;
  e := TCellData.Create(3);
  e.Visible := false;
  e.LoadFile (XlsMenuPath, true);
end;
function ReturnMenuName(row, col, cols : integer) : string;
var
  LName : string;
  Li : integer;
begin
  LName := e.CurrentSheet.Cell(row, col).AsString;
  for Li := 1 to cols - 1 do
    LName := LName + ifThen(LName[Length(LName)] <> ' ',' ','') + (e.CurrentSheet.Cell(row + Li, col).AsString);

  Result := LName;
end;
function LoadMenuDay(day : integer) : TDayMenu;
var
  LDay : integer;
  SpecAlergens : string; // Weekly ma alergeny v nazvu
  SpecName : string;
  Si : integer;
begin
  case day of
    1 : Lday := Menu_mon;
    2 : Lday := Menu_tue;
    3 : Lday := Menu_wed;
    4 : Lday := Menu_thu;
    5 : Lday := Menu_fri;
  end;

  //Datum
  Result.MenuDate := e.CurrentSheet.Cell(date_row, LDay - 1).AsDateTime;

  //Soups
  Result.Soups[1].MenuID   := 1;
  Result.Soups[1].Name     := Trim(ReturnMenuName(Soup_1, LDay, 2));
  Result.Soups[1].Alergens := Trim(e.CurrentSheet.Cell(Soup_1 + 2, LDay ).AsString);

  Result.Soups[2].MenuID   := 2;
  Result.Soups[2].Name     := Trim(ReturnMenuName(Soup_2, LDay, 2));
  Result.Soups[2].Alergens := Trim(e.CurrentSheet.Cell(Soup_2 + 2, LDay ).AsString);

  //Main Courses
  Result.MainCourses[1].MenuID   := 1;
  Result.MainCourses[1].Name     := Trim(ReturnMenuName(Main_1, LDay, 3));
  Result.MainCourses[1].Alergens := Trim(e.CurrentSheet.Cell(Main_1 + 3, LDay ).AsString);
  if Result.MainCourses[1].Alergens = '' then
    Result.MainCourses[1].Alergens := Trim(e.CurrentSheet.Cell(Main_1 + 4, LDay ).AsString);

  Result.MainCourses[2].MenuID   := 2;
  Result.MainCourses[2].Name     := Trim(ReturnMenuName(Main_2, LDay, 3));
  Result.MainCourses[2].Alergens := Trim(e.CurrentSheet.Cell(Main_2 + 3, LDay ).AsString);
  if Result.MainCourses[2].Alergens = '' then
    Result.MainCourses[2].Alergens := Trim(e.CurrentSheet.Cell(Main_2 + 4, LDay ).AsString);

  Result.MainCourses[3].MenuID   := 3;
  Result.MainCourses[3].Name     := Trim(ReturnMenuName(Main_3, LDay, 3));
  Result.MainCourses[3].Alergens := Trim(e.CurrentSheet.Cell(Main_3 + 3, LDay ).AsString);
  if Result.MainCourses[3].Alergens = '' then
    Result.MainCourses[3].Alergens := Trim(e.CurrentSheet.Cell(Main_3 + 4, LDay ).AsString);

  Result.MainCourses[4].MenuID   := 4;
  Result.MainCourses[4].Name     := Trim(ReturnMenuName(Main_4, LDay, 3));
  Result.MainCourses[4].Alergens := Trim(e.CurrentSheet.Cell(Main_4 + 3, LDay ).AsString);
  if Result.MainCourses[4].Alergens = '' then
    Result.MainCourses[4].Alergens := Trim(e.CurrentSheet.Cell(Main_4 + 4, LDay ).AsString);

  Result.MainCourses[5].MenuID   := 5;
  Result.MainCourses[5].Name     := Trim(ReturnMenuName(Main_5, LDay, 2)); // Paty je jen na dva radky
  Result.MainCourses[5].Alergens := Trim(e.CurrentSheet.Cell(Main_5 + 2, LDay ).AsString); // u pateho by alergeny snad doufam meli byt na jednom miste

  //Weekly
  SpecName := Trim(ReturnMenuName(Spec_Row, Spec_Col, 2));
  for Si := Length(SpecName) downto 1 do
  begin
    if(SpecName[Si] = ' ') then
      break;
    SpecAlergens := SpecName[Si] + SpecAlergens;
    Delete(SpecName,Length(SpecName),1);
  end;
  Result.WeeklyCourse.MenuID   := 7;
  Result.WeeklyCourse.Name     := SpecName;
  Result.WeeklyCourse.Alergens := SpecAlergens;
end;
procedure LoadMenu;
begin
  for i := 1 to 5 do
    MenuBatch[i] := LoadMenuDay(i);
end;
function ReturnAlergenRID(Number : string) : integer;
begin
  if not assigned(TAlergen) then
     TAlergen.CreateDM;
   TAlergen.AktIndexDM := 1;
   TAlergen.Abbr := Trim(Number);
   if TAlergen.DoGetKeyDM then
     Result := TAlergen.RID
   else
     HlasOK('Spatne zadany alergen!');
end;
function CreateMeal(name, alergens : string; mealType : TLunchMealType): integer;
var
AlergenIndex : integer;
AlergenItemID : integer;
alergenString : string;
begin
   if not assigned(TMeal) then
     TMeal.CreateDM;
   TMeal.NovyDM := True;
   TMeal.NactiDM(True);
   TMeal.StatusId := 5028;
   TMeal.Name := name;
   TMeal.TypeId := mealType;

   AlergenString := '';
   AlergenItemID := 1;

   for AlergenIndex := 1 to Length(Alergens) do
   begin
     if Alergens[AlergenIndex] <> ',' then
       AlergenString := AlergenString + Alergens[AlergenIndex];
     if((Alergens[AlergenIndex] = ',') or ((AlergenIndex >= Length(Alergens)) and (AlergenString <> ''))) then
     begin //Addni alergena
      with TMeal.AlergenChild do (remAppend)
       begin
         TMeal.AlergenChild.ItemNo := AlergenItemID;
         TMeal.AlergenChild.LunchAlergensRID := ReturnAlergenRID(AlergenString);
       end;
       AlergenItemID := AlergenItemID + 1;
       AlergenString := '';
       continue;
     end;
   end;
     TMeal.UlozDM;
     TMeal.VystupZmenaDM;
   result := TMeal.RID;
end;
function ReturnMealRID(name, alergens : string; mealType : TLunchMealType) : integer;
begin
   if not assigned(TMeal) then
     TMeal.CreateDM;
   TMeal.AktIndexDM := 1;
   TMeal.Name := name;
   TMeal.TypeId := mealType;
   if TMeal.DoGetKeyDM then
   begin
     Result := TMeal.RID;
   end
   else
   begin
     Result := CreateMeal(name, alergens, mealtype);
   end;
end;
procedure ImportMenu;
begin
 for i := 1 to 5 do // Jedeme po dnech
 begin
   if not assigned(TMenu) then
     TMenu.CreateDM;
   TMenu.AktIndexDM := 1;
   TMenu.StatusId := activeStatusID;
   TMenu.Date := menuBatch[i].MenuDate;
   if TMenu.DoGetKeyDM then
   begin
     HlasOk('Aktivni menu s datem ' + DateToStr(TMenu.Date) + ' jiz existuje, preskakuji...');
   end
   else
   begin
     TMenu.NovyDM := True;
     Try
       TMenu.NactiDm(True);
       TMenu.Date := menuBatch[i].MenuDate;
       TMenu.StatusId := activeStatusID;
       for j := 1 to 2 do
       begin
         with TMenu.MealChild do (remAppend)
         begin
           TMenu.MealChild.ItemNo := j;
           TMenu.MealChild.LunchMealRID := ReturnMealRID(menuBatch[i].Soups[j].Name, menuBatch[i].Soups[j].Alergens, lmtSoup);
         end;
       end;
       for j := 1 to 5 do
       begin
         with TMenu.MealChild do (remAppend)
         begin
           TMenu.MealChild.ItemNo := j;
           TMenu.MealChild.LunchMealRID := ReturnMealRID(menuBatch[i].MainCourses[j].Name, menuBatch[i].MainCourses[j].Alergens, lmtMainCourse);
         end;
       end;
       with TMenu.MealChild do (remAppend)
       begin
         TMenu.MealChild.ItemNo := 7;
         TMenu.MealChild.LunchMealRID := ReturnMealRID(menuBatch[i].WeeklyCourse.Name, menuBatch[i].WeeklyCourse.Alergens, lmtMainCourse);
       end;
       Tmenu.UlozDM;
     except
       HlasOK('Pri importu se stala chyba, menu nebylo nahráno.');
     end;
       TMenu.VystupZmenaDM;
   end;
 end;
 TMenu.Free;
end;

begin
  if(not(AktDM is TSpecialLunchMenu)) then
  begin
    HlasOk('Skript je mozno spustit pouze nad tridou TSpecialLunchMenu!');
    exit;
  end;

  OpenMenuFile;
  LoadMenu;
  ImportMenu;
end.