<?php
namespace AppBundle\Form;

use K2Bundle\Entity\TSpecialLunchMeal;
use K2Bundle\Form\K2Type;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\OptionsResolver\OptionsResolver;

use Symfony\Component\Form\Extension\Core\Type;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\IntegerType;
use AppBundle\Entity\LunchOrderBatchChild;
use Symfony\Component\Form\FormEvent;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;

class LunchOrderBatchChildType extends AbstractType {
    public function buildForm(FormBuilderInterface $builder, array $options) {
        $builder->addEventListener(FormEvents::PRE_SET_DATA, function (FormEvent $event) {
            $order = $event->getData();
            $form = $event->getForm();
    
            if ($order) {
                $form
                ->add('soupRID', ChoiceType::class, [
                    'label'    => 'Polévka:',
                    'choices'  => $order->getSoups(), 
                    'expanded' => true,
                    'multiple' => false,
                    'required' => false,
                    'placeholder' => 'Bez polévky'          
                ])
                ->add('mainCourseRID', ChoiceType::class, [
                    'label'    => 'Hlavní chod:',
                    'choices'  => $order->getMainCourses(),
                    'expanded' => true,
                    'multiple' => false,
                    'required' => false,
                    'placeholder' => 'Bez hlavního chodu',
                    'choice_attr' => function($val, $key, $index) {
                        return [ 'class' => 'star'];
                    }           
                ]);               
            }
        });
        $builder
        ->getForm();
    }
    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => LunchOrderBatchChild::class,
        ]);
    }
}
